write-b -- -------------------------- --;
write   -- Les requtes du chapitre 9 --;
write   -- La fonction group_concat   --;
write-a -- -------------------------- --;

openDB CLICOM.db;

write -- Liste des produits par commande. Dans le dsordre --;
select NCOM,count(*) as Nombre,group_concat(NPRO,',') as Produits
from   DETAIL
group by NCOM;

write-b -- Liste des produits par commande. Par ordre alphabtique inverse --;
select NCOM,count(*) as Nombre,group_concat(NPRO,',') as Produits
from   (select NCOM,NPRO from DETAIL order by NCOM,NPRO desc)
group by NCOM;

write-b -- Liste les localits par produit --;
select P.NPRO as Produit,
       group_concat(LOCALITE,',') as Localits
from   CLIENT C,COMMANDE M,DETAIL D,PRODUIT P
where  C.NCLI = M.NCLI and M.NCOM = D.NCOM and D.NPRO = P.NPRO
group by P.NPRO;

write-b -- Liste les localits par produit --;
select  Produit,group_concat(Localite,',') as Localites
from   (select distinct P.NPRO as Produit,LOCALITE as Localite
        from   CLIENT C,COMMANDE M,DETAIL D,PRODUIT P
        where  C.NCLI = M.NCLI and M.NCOM = D.NCOM
        and D.NPRO = P.NPRO
        order by Produit,Localite)
group by Produit;

write-b -- Liste les produits par localit --;
select  Localite,group_concat(Produit,',') as Produits
from   (select distinct P.NPRO as Produit,LOCALITE as Localite
        from   CLIENT C,COMMANDE M,DETAIL D,PRODUIT P
        where  C.NCLI = M.NCLI and M.NCOM = D.NCOM
        and    D.NPRO = P.NPRO
        order by Localite,Produit)
group by Localite;

write-b -- Synthse des commandes par client --;
select  Client,group_concat(Commande,';') as Commandes
from   (select NCLI as Client,
        M.NCOM||'['||group_concat(NPRO,',')||']' as Commande
        from   COMMANDE M,DETAIL D
        where  M.NCOM = D.NCOM
        group by NCLI,M.NCOM)
group by Client;

write-b -- Gnration d'objets JSON --;
select  '{"NCLI":"'||Client||'","Commandes":['||group_concat(Commande,',')||']}' as JSON
from   (select NCLI as Client,
        '{"NCOM":"'||M.NCOM||'","DETAILS":['||group_concat('"'||NPRO||'"',',')||']}' as Commande
        from   COMMANDE M,DETAIL D
        where  M.NCOM = D.NCOM
        group by NCLI,M.NCOM)
group by Client;

closeDB;
