write-b -- -------------------------- --;
write   -- Les requtes du chapitre 9 --;
write   -- Le catalogue               --;
write-a -- -------------------------- --;

openDB CLICOM.db;

create view if not exists COM_COMPLETE
as  select NCOM,COM.NCLI as NCLI,NOM as NOMCLI,LOCALITE as LOC,DATECOM
    from   CLIENT CLI,COMMANDE COM
    where  COM.NCLI = CLI.NCLI;

create view if not exists HABITUDE_ACHAT
as  select LOCALITE,P.NPRO,sum(QCOM*PRIX) as VOLUME
    from   CLIENT CLI,COMMANDE COM,DETAIL D,PRODUIT P
    where  COM.NCLI = CLI.NCLI
    and    D.NCOM = COM.NCOM
    and    P.NPRO = D.NPRO
    group by LOCALITE, P.NPRO;

createDictionary;

write-b DICTIONNAIRE DE LA BASE DE DONNEES CLICOM.db;
write   ============================================;
write-b Table SYS_TABLE;
select TableID,TableName,TableType from SYS_TABLE;

write-b Table SYS_COLUMN;
select ColID,TableID,ColSeq,ColName,ColType,ColLen1,ColLen2,ColNull,DefVal,PKseq from SYS_COLUMN;

write-b Table SYS_KEY;
select KeyID,KeyType,TableID,KeyName,TableTarget,KeyTarget,onDelete,onUpdate,Match,KeyNull from SYS_KEY;

write-b Table SYS_KEY_COMP;
select KeyCompID,KeyID,CompSeq,ColID,ColName,ColNull,CompTarget from SYS_KEY_COMP;

write-b Vue SYS_INTER_TABLE;
select SourceTable,SourceKey,TargetKey,TargetTable from SYS_INTER_TABLE;

drop view COM_COMPLETE;
drop view HABITUDE_ACHAT;

write-b Colonnes de la table DETAIL;
select ColName,ColType,ColLen1,ColNull
from   SYS_COLUMN C, SYS_TABLE T
where  C.TableID = T.TableID
and    TableName = 'DETAIL';

write-b Tables dont une colonne a un nom commenant par "NCOM";
select TableName
from   SYS_TABLE
where  TableID  in (select TableID
                    from   SYS_COLUMN
                    where  ColName like 'NCOM%')
                    and    TableType = 'base';

ask table = Table:[select TableName from SYS_TABLE];
if ('$DIALOGbutton$' = 'OK');
   write-b Tables rfrenant directement ou indirectement la table $table$;
   with recursive R(Rang,Nom)
   as (values (1,'$table$')
       union all
       select R.Rang+1, IT.SourceTable
       from SYS_INTER_TABLE IT, R
       where IT.TargetTable = R.Nom)
   select distinct * from R;
endif;

write;

closeDB;
