write-b -- -------------------------- --;
write   -- Les requtes du chapitre 9 --;
write   -- Les vues SQL               --;
write-a -- -------------------------- --;

openDB CLICOM.db;

write-b -- --------------------- --;
write   -- Vue COM_COMPLETE      --;
write-a -- --------------------- --;

create temporary view COM_COMPLETE
 as
select NCOM,COM.NCLI as NCLI,NOM as NOMCLI,LOCALITE as LOC,DATECOM
from   CLIENT CLI,COMMANDE COM
where  COM.NCLI = CLI.NCLI;

select * from COM_COMPLETE;

select NOMCLI,NCOM,DATECOM
from   COM_COMPLETE
where  LOC = 'Toulouse'; 

select distinct NPRO
from   DETAIL
where  NCOM in ( select NCOM
                 from   COM_COMPLETE
                 where  LOC = 'Toulouse'); 

select LOC, count(*)
from   COM_COMPLETE CC, DETAIL D
where  CC.NCOM = D.NCOM
group by LOC;

select NOM,NCOM,DATECOM
from   CLIENT CLI,COMMANDE COM
where  COM.NCLI = CLI.NCLI
and    LOCALITE = 'Toulouse';


write-b -- --------------------- --;
write   -- Vue HABITUDE_ACHAT    --;
write-a -- --------------------- --;

create temporary view HABITUDE_ACHAT
 as
select LOCALITE,P.NPRO,sum(QCOM*PRIX) as VOLUME
from   CLIENT CLI,COMMANDE COM,DETAIL D,PRODUIT P
where  COM.NCLI = CLI.NCLI
and    D.NCOM = COM.NCOM
and    P.NPRO = D.NPRO
group by LOCALITE, P.NPRO;

select * 
from   HABITUDE_ACHAT
where  LOCALITE in ('Poitiers','Toulouse');


write-b -- --------------------- --;
write   -- Vue VAL_STOCK_ACTU    --;
write-a -- --------------------- --;

-- En dcomposant via une vue

create temporary view VAL_STOCK_ACTU
 as
select (QSTOCK - sum(D.QCOM))*PRIX as VALEUR
from   DETAIL D, PRODUIT P 
where  D.NPRO = P.NPRO
group by P.NPRO, QSTOCK, PRIX; 

select sum(VALEUR) from VAL_STOCK_ACTU;

-- Idem en une requte complexe

select sum(VALEUR)
from (select (QSTOCK - sum(D.QCOM))*PRIX as VALEUR
      from   DETAIL D, PRODUIT P 
      where  D.NPRO = P.NPRO
      group by P.NPRO, QSTOCK, PRIX);

-- Idem  l'aide d'une CTE

with VAL_STOCK_ACTU(VALEUR)
as (select (QSTOCK - sum(D.QCOM))*PRIX
    from   DETAIL D, PRODUIT P 
    where  D.NPRO = P.NPRO
    group by P.NPRO, QSTOCK, PRIX)
select sum(VALEUR) from VAL_STOCK_ACTU;


-- En SQLite, les vues sont 'read-only'.
-- Utiliser plutt les triggers 'instead-of'.

goto Read-only;

   write-b -- --------------------- --;
   write   -- Mise  jour d'une vue --;
   write-a -- --------------------- --;

   write-ab -- Sans filtrage des MAJ;

   create temporary view CLI_POITIERS
    as
   select NCLI,NOM,ADRESSE,LOCALITE,CAT,COMPTE
   from   CLIENT
   where  LOCALITE = 'Poitiers';

   insert into CLI 
        values ('B313','DURAND','place Monge','Toulouse',null,0);

   select * from CLI_POITIERS;

   write-ab -- Avec filtrage des MAJ;

   drop view CLI;

   create temporary view CLI_POITIERS
    as
   select NCLI,NOM,ADRESSE,LOCALITE,CAT,COMPTE
   from   CLIENT
   where  LOCALITE = 'Poitiers'
   with check option;

onError continue;

insert into CLI 
     values ('B313','DURAND','place Monge','Toulouse',null,0);

write SQLdiag = $SQLdiag$, EXTENDEDdiag = $EXTENDEDdiag$;

select * from CLI;

onError stop;

label Read-only;

abortDB;

write;


write-b -- ------------------------------------ --;
write   -- Les vues comme mcanisme d'volution --;
write-a -- ------------------------------------ --;

write -- Donnes de l'ancien schma -;

select * from CLIENT;

alter table CLIENT rename to XCLIENT;

create temporary table CLIENT_SIG(
       NCLI char(10) not null primary key,
       NOM char(32) not null,
       ADRESSE char(60) not null,
       LOCALITE char(30) not null);

create temporary table CLIENT_COM(
       NCLI char(10) not null primary key,
       CAT char(2),
       COMPTE decimal(9,2) not null);

insert into CLIENT_SIG select NCLI,NOM,ADRESSE,LOCALITE from XCLIENT;
insert into CLIENT_COM select NCLI,CAT,COMPTE from XCLIENT;

create temporary view CLIENT
 as
select CS.NCLI,NOM,ADRESSE,LOCALITE,CAT,COMPTE
from   CLIENT_SIG CS, CLIENT_COM CC
where  CS.NCLI = CC.NCLI;

write-b -- Donnes du nouveau schma --;

select * from CLIENT;

-- Remise en ordre de la BD --

drop table CLIENT_SIG;
drop table CLIENT_COM;
drop view CLIENT;

alter table XCLIENT rename to CLIENT;

closeDB;